/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "./type";
import { FilterExpression } from "./FilterExpression";
export class FilterFactory extends Base {
    static get instance() {
        if (FilterFactory.a4 == null) {
            FilterFactory.a4 = new FilterFactory();
        }
        return FilterFactory.a4;
    }
    static build(a) {
        let b = FilterFactory.instance;
        return a(b);
    }
    property(a) {
        return FilterExpression.property(a);
    }
    literal(a) {
        return FilterExpression.literal(a);
    }
    group(a) {
        return FilterExpression.operation(a, 15, null);
    }
    and(a, b) {
        return FilterExpression.operation(a, 7, b);
    }
    or(a, b) {
        return FilterExpression.operation(a, 8, b);
    }
    not(a) {
        return FilterExpression.operation(a, 9, null);
    }
    add(a, b) {
        return FilterExpression.operation(a, 10, b);
    }
    divide(a, b) {
        return FilterExpression.operation(a, 13, b);
    }
    equal(a, b) {
        return FilterExpression.operation(a, 1, b);
    }
    greaterThan(a, b) {
        return FilterExpression.operation(a, 3, b);
    }
    greaterThanOrEqual(a, b) {
        return FilterExpression.operation(a, 4, b);
    }
    lessThan(a, b) {
        return FilterExpression.operation(a, 5, b);
    }
    lessThanOrEqual(a, b) {
        return FilterExpression.operation(a, 6, b);
    }
    modulus(a, b) {
        return FilterExpression.operation(a, 14, b);
    }
    multiply(a, b) {
        return FilterExpression.operation(a, 12, b);
    }
    notEqual(a, b) {
        return FilterExpression.operation(a, 2, b);
    }
    subtract(a, b) {
        return FilterExpression.operation(a, 11, b);
    }
    ceiling(a) {
        return FilterExpression.$function(19, a);
    }
    concat(a, b) {
        return FilterExpression.$function(10, a, b);
    }
    concat1(a, b) {
        return FilterExpression.$function(10, a, FilterExpression.literal(b));
    }
    contains(a, b) {
        return FilterExpression.$function(0, a, b);
    }
    contains1(a, b) {
        return FilterExpression.$function(0, a, FilterExpression.literal(b));
    }
    day(a) {
        return FilterExpression.$function(11, a);
    }
    endsWith(a, b) {
        return FilterExpression.$function(1, a, b);
    }
    endsWith1(a, b) {
        return FilterExpression.$function(1, a, FilterExpression.literal(b));
    }
    floor(a) {
        return FilterExpression.$function(18, a);
    }
    hour(a) {
        return FilterExpression.$function(12, a);
    }
    indexOf(a, b) {
        return FilterExpression.$function(4, a, b);
    }
    indexOf1(a, b) {
        return FilterExpression.$function(4, a, FilterExpression.literal(b));
    }
    length(a) {
        return FilterExpression.$function(3, a);
    }
    minute(a) {
        return FilterExpression.$function(13, a);
    }
    month(a) {
        return FilterExpression.$function(14, a);
    }
    replace(a, b, c) {
        return FilterExpression.$function(5, a, b, c);
    }
    replace2(a, b, c) {
        return FilterExpression.$function(5, a, FilterExpression.literal(b), c);
    }
    replace1(a, b, c) {
        return FilterExpression.$function(5, a, b, FilterExpression.literal(c));
    }
    replace3(a, b, c) {
        return FilterExpression.$function(5, a, FilterExpression.literal(b), FilterExpression.literal(c));
    }
    round(a) {
        return FilterExpression.$function(17, a);
    }
    second(a) {
        return FilterExpression.$function(15, a);
    }
    startsWith(a, b) {
        return FilterExpression.$function(2, a, b);
    }
    startsWith1(a, b) {
        return FilterExpression.$function(2, a, FilterExpression.literal(b));
    }
    substring(a, b) {
        return FilterExpression.$function(6, a, b);
    }
    substring3(a, b) {
        return FilterExpression.$function(6, a, FilterExpression.literal(b));
    }
    substring1(a, b, c) {
        return FilterExpression.$function(6, a, b, c);
    }
    substring4(a, b, c) {
        return FilterExpression.$function(6, a, FilterExpression.literal(b), c);
    }
    substring2(a, b, c) {
        return FilterExpression.$function(6, a, b, FilterExpression.literal(c));
    }
    substring5(a, b, c) {
        return FilterExpression.$function(6, a, FilterExpression.literal(b), FilterExpression.literal(c));
    }
    toLower(a) {
        return FilterExpression.$function(7, a);
    }
    toUpper(a) {
        return FilterExpression.$function(8, a);
    }
    trim(a) {
        return FilterExpression.$function(9, a);
    }
    year(a) {
        return FilterExpression.$function(16, a);
    }
    date(a) {
        return FilterExpression.$function(20, a);
    }
    time(a) {
        return FilterExpression.$function(21, a);
    }
    now() {
        return FilterExpression.$function(16);
    }
    isOf(a, b) {
        return FilterExpression.$function(16, a);
    }
    cast(a, b) {
        return FilterExpression.$function(24, a);
    }
}
FilterFactory.$t = markType(FilterFactory, 'FilterFactory');
FilterFactory.a4 = null;
