import { Base, Type } from "./type";
import { IFilterExpression } from "./IFilterExpression";
import { FilterExpressionOperatorType } from "./FilterExpressionOperatorType";
import { FilterExpressionFunctionType } from "./FilterExpressionFunctionType";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceSchemaPropertyType } from "./DataSourceSchemaPropertyType";
import { IOperationFilterExpression } from "./IOperationFilterExpression";
import { IFunctionFilterExpression } from "./IFunctionFilterExpression";
import { FilterExpressionCollection } from "./FilterExpressionCollection";
import { IPropertyReferenceFilterExpression } from "./IPropertyReferenceFilterExpression";
import { ILiteralFilterExpression } from "./ILiteralFilterExpression";
export declare abstract class FilterExpression extends Base implements IFilterExpression {
    static $t: Type;
    private bv;
    abstract readonly precedence: number;
    private bw;
    markAutoGenerated(): void;
    readonly isAutoGenerated: boolean;
    static operation3(a: string, b: FilterExpressionOperatorType, c: any): OperationFilterExpression;
    static operation(a: IFilterExpression, b: FilterExpressionOperatorType, c: IFilterExpression): OperationFilterExpression;
    static operation2(a: string, b: FilterExpressionOperatorType, c: IFilterExpression): OperationFilterExpression;
    static operation1(a: IFilterExpression, b: FilterExpressionOperatorType, c: any): OperationFilterExpression;
    static $function(a: FilterExpressionFunctionType, ...b: IFilterExpression[]): FunctionFilterExpression;
    protected b0(): void;
    protected abstract by(): boolean;
    static property(a: string): PropertyReferenceFilterExpression;
    static nullLiteral(): LiteralFilterExpression;
    static literal(a: any): LiteralFilterExpression;
    static unquotedLiteral(a: string): LiteralFilterExpression;
    match(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): boolean;
    bz(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): boolean;
    private bx;
    abstract evaluate(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): any;
    protected get_isPropertyReference(): boolean;
    readonly isPropertyReference: boolean;
    protected get_isOperation(): boolean;
    readonly isOperation: boolean;
    protected get_isFunction(): boolean;
    readonly isFunction: boolean;
    protected get_isLiteral(): boolean;
    readonly isLiteral: boolean;
    protected get_isNull(): boolean;
    readonly isNull: boolean;
    group(): FilterExpression;
    and(a: IFilterExpression): FilterExpression;
    or(a: IFilterExpression): FilterExpression;
    not(): FilterExpression;
    add(a: IFilterExpression): FilterExpression;
    add1(a: any): FilterExpression;
    plus(a: IFilterExpression): FilterExpression;
    plus1(a: any): FilterExpression;
    divide(a: IFilterExpression): FilterExpression;
    divide1(a: any): FilterExpression;
    dividedBy(a: IFilterExpression): FilterExpression;
    dividedBy1(a: any): FilterExpression;
    isEqualTo(a: IFilterExpression): FilterExpression;
    isEqualTo1(a: any): FilterExpression;
    isGreaterThan(a: IFilterExpression): FilterExpression;
    isGreaterThan1(a: any): FilterExpression;
    isGreaterThanOrEqualTo(a: IFilterExpression): FilterExpression;
    isGreaterThanOrEqualTo1(a: any): FilterExpression;
    isLessThan(a: IFilterExpression): FilterExpression;
    isLessThan1(a: any): FilterExpression;
    isLessThanOrEqualTo(a: IFilterExpression): FilterExpression;
    isLessThanOrEqualTo1(a: any): FilterExpression;
    modulo(a: IFilterExpression): FilterExpression;
    modulo1(a: any): FilterExpression;
    multiply(a: IFilterExpression): FilterExpression;
    multiply1(a: any): FilterExpression;
    times(a: IFilterExpression): FilterExpression;
    times1(a: any): FilterExpression;
    isNotEqualTo(a: IFilterExpression): FilterExpression;
    isNotEqualTo1(a: any): FilterExpression;
    subtract(a: IFilterExpression): FilterExpression;
    subtract1(a: any): FilterExpression;
    minus(a: IFilterExpression): FilterExpression;
    minus1(a: any): FilterExpression;
    ceiling(): FilterExpression;
    concat(a: IFilterExpression): FilterExpression;
    concat1(a: string): FilterExpression;
    contains(a: IFilterExpression): FilterExpression;
    contains1(a: string): FilterExpression;
    day(): FilterExpression;
    endsWith(a: IFilterExpression): FilterExpression;
    endsWith1(a: string): FilterExpression;
    floor(): FilterExpression;
    hour(): FilterExpression;
    indexOf(a: IFilterExpression): FilterExpression;
    indexOf1(a: string): FilterExpression;
    length(): FilterExpression;
    minute(): FilterExpression;
    month(): FilterExpression;
    replace(a: FilterExpression, b: IFilterExpression): FilterExpression;
    replace2(a: string, b: IFilterExpression): FilterExpression;
    replace1(a: IFilterExpression, b: string): FilterExpression;
    replace3(a: string, b: string): FilterExpression;
    round(): FilterExpression;
    second(): FilterExpression;
    startsWith(a: IFilterExpression): FilterExpression;
    startsWith1(a: string): FilterExpression;
    substring(a: IFilterExpression): FilterExpression;
    substring3(a: number): FilterExpression;
    substring1(a: IFilterExpression, b: IFilterExpression): FilterExpression;
    substring4(a: number, b: IFilterExpression): FilterExpression;
    substring2(a: IFilterExpression, b: number): FilterExpression;
    substring5(a: number, b: number): FilterExpression;
    toLower(): FilterExpression;
    toUpper(): FilterExpression;
    trim(): FilterExpression;
    year(): FilterExpression;
    date(): FilterExpression;
    time(): FilterExpression;
    now(): FilterExpression;
    isOf(a: DataSourceSchemaPropertyType): FilterExpression;
    cast(a: DataSourceSchemaPropertyType): FilterExpression;
    isOf1(a: string): FilterExpression;
    cast1(a: string): FilterExpression;
}
export declare class OperationFilterExpression extends FilterExpression implements IOperationFilterExpression {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: IFilterExpression, c: FilterExpressionOperatorType, d: IFilterExpression);
    constructor(a: number, b: string, c: FilterExpressionOperatorType, d: IFilterExpression);
    constructor(a: number, b: IFilterExpression, c: FilterExpressionOperatorType, d: any);
    constructor(a: number, b: string, c: FilterExpressionOperatorType, d: any);
    constructor(a: number, ..._rest: any[]);
    private b2;
    private b4;
    private b3;
    private b5;
    private b1;
    protected get_isOperation(): boolean;
    protected by(): boolean;
    readonly isComparisonOperation: boolean;
    propertyName: string;
    readonly hasPropertyName: boolean;
    value: any;
    readonly hasValue: boolean;
    left: IFilterExpression;
    readonly hasLeft: boolean;
    right: IFilterExpression;
    readonly hasRight: boolean;
    operator: FilterExpressionOperatorType;
    readonly hasOperator: boolean;
    protected readonly cb: boolean;
    protected get_precedence(): number;
    readonly precedence: number;
    evaluate(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): any;
    private ce;
    private cf;
    private cd;
}
export declare class FunctionFilterExpression extends FilterExpression implements IFunctionFilterExpression {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: FilterExpressionFunctionType, ...c: IFilterExpression[]);
    constructor(a: number, ..._rest: any[]);
    private b2;
    private b1;
    protected get_isFunction(): boolean;
    protected by(): boolean;
    functionType: FilterExpressionFunctionType;
    protected readonly b3: boolean;
    readonly functionArguments: FilterExpressionCollection;
    readonly hasFunctionArguments: boolean;
    evaluate(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): any;
    protected get_precedence(): number;
    readonly precedence: number;
    private b4;
    private b6;
    private b5;
}
export declare class PropertyReferenceFilterExpression extends FilterExpression implements IPropertyReferenceFilterExpression {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: string);
    constructor(a: number, ..._rest: any[]);
    protected get_isPropertyReference(): boolean;
    protected get_precedence(): number;
    readonly precedence: number;
    protected by(): boolean;
    private b1;
    propertyReference: string;
    evaluate(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): any;
}
export declare class LiteralFilterExpression extends FilterExpression implements ILiteralFilterExpression {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: any);
    constructor(a: number, b: string, c: boolean);
    constructor(a: number, ..._rest: any[]);
    protected get_precedence(): number;
    readonly precedence: number;
    private b2;
    private b1;
    protected get_isLiteral(): boolean;
    protected get_isNull(): boolean;
    literalValue: any;
    leaveUnquoted: boolean;
    protected by(): boolean;
    evaluate(a: any, b: IDataSourceDataProvider, c: IDataSourceSchema): any;
}
